<template>
  <SinglePane>
    <div class="tenders-container">
      <div class="tabs-container">
        <ObTabs
          v-model="selectedTab"
          :items="tabs"
          @on-change-tab="onChangeTab"
        />
      </div>

      <Reports v-if="selectedTab.name === 'reports'" />

      <TendersList
        v-else
        :selected-tab="selectedTab"
      />
    </div>
  </SinglePane>
</template>

<script>
  import { mapActions } from 'vuex';

  import TendersList from './tabs/tendersList';
  import Reports from './tabs/reports';

  import SinglePane from "common-components/src/obComponents/obSinglePanels";
  import ObTabs from 'common-components/src/obComponents/obTabs';

    export default {
      name: "tenders-index",
      components: {
        SinglePane,
        ObTabs,
        TendersList,
        Reports
      },
      data() {
        return {
          selectedTab: { type: null },
          isTenderMenuHovered: false,
          tabs: [
            {
              title: 'Все тендеры',
              type: null,
              name: 'all',
              id: 1
            },
            {
              title: 'RFI',
              type: 'RFI',
              name: 'rfi',
              id: 2
            },
            {
              title: 'RFQ',
              type: 'RFQ',
              name: 'rfq',
              id: 3
            },
            {
              title: 'Архив',
              type: null,
              name: 'archive',
              id: 4
            },
            {
              title: 'Отчеты',
              type: null,
              name: 'reports',
              icon: 'document',
              isAlignRight: true,
              id: 5
            }
          ]
        }
      },
      computed: {
        tendersType: ({ $route }) => $route?.query?.tenders_type || 'all',
      },
      created() {
        this.setCurrentUserRole();
      },
      beforeMount() {
        this.onChangeTab(this.tabs.find(tab => tab.name === this.tendersType))
      },
      methods: {
        ...mapActions({
          setCurrentUserRole: 'tenders/setCurrentUserRole'
        }),
        onChangeTab(e) {
          if (this.selectedTab.name === e.name) {
            return;
          }

          if (this.$route.query.tenders_type !== e.name) {
            this.$router.replace({
              ...this.$route,
              query: {
                ...this.$route.query,
                tenders_type: e.name,
                archived: e.name === 'archive' ? 'true' : undefined
              }
            })
          }

          this.selectedTab = e;
        }
      }
    };
</script>

<style lang="scss" scoped>
  .tenders-container {
    min-height: calc(100% - 70px);
  }

  .tabs-container {
    padding: 20px 20px 0;
  }
</style>
